<p align="center">
    <img src="https://i.imgur.com/Kd7N6uf.png">
</p>

---

For the end user, PlotSquared is packed with a tonne of cool features.
It allows you to merge plots, and build together with your friends. 
You can also change a lot of plot specific settings in the form of
flags. Such as: weather, time, game modes, pvp status. 

Whilst we provide a whole load of unique features, the biggest focus
is to provide a lag-free and smooth experience.

***NOTE:** This is the branch for the 1.13+ version of PlotSquared. Switch to the master branch for legacy PlotSquared.*

## Links

* [Download](https://github.com/IntellectualSites/PlotSquared/releases/tag/dev)
* [[Jenkins (Dev Builds)](https://ci.athion.net/job/PlotSquared-Breaking/)] [[Jenkins (Releases)](https://ci.athion.net/job/PlotSquared-Releases/)]
* [Spigot Page](https://www.spigotmc.org/resources/plotsquared.1177/)
* [Discord](https://discord.gg/ngZCzbU)
* [Wiki](https://github.com/intellectualcrafters/plotsquared/wiki)

### Developer Resources
* [[JavaDoc](https://ci.athion.net/job/PlotSquared-Breaking/javadoc/)]
* [[Maven Repo (CI)](http://ci.athion.net/job/PlotSquared-Breaking/ws/mvn/)]
* [API Documentation](https://github.com/IntellectualSites/PlotSquared/wiki/Developer-documentation-(WIP))

# Building
Gradle is the **recommended** way to build the project. Use `./gradlew build` in the main project directory to build the project. Gradle is required if you intend to build or develop the Sponge module.
If you prefer to use maven, a `pom.xml` file is provided for working with the Bukkit part of the plugin.

# Contributing
If you feel like you can improve the plugin any way, then you are
more than welcome to contribute to PlotSquared. It would be highly
appreciated if you made sure to test your code before committing it, 
as it will save us a lot of time and effort.

### Code Style

If you are planning to commit any changes to the project,
it would be highly appreciated if you were to follow the 
project code style conventions. To make this easier we have
provided settings that can be imported into your IDE.

**Eclipse:**
`Window > Preferences > Java > Code Style > Formatter`
Press `Import` and select `...path/to/project/code_style.xml`

**IntelliJ:**
`File > Settings > Editor > Code Style`. Next to "Scheme" there is a cog wheel, press that and then
`Import Scheme > IntelliJ IDEA Code Style XML` and then select `..path/to/project/code_style.xml`

## Suggestions
Suggestions are welcome! We have a separate issue tracker for suggestions, that can be found in [this](https://github.com/IntellectualSites/PlotSquaredSuggestions) repository.

# Official Addons
* [Plot2Dynmap](http://www.spigotmc.org/resources/plot2dynmap.1292/)
* [AdvPlots](http://www.spigotmc.org/resources/advplots-%CE%B2.1500/)
* [PlotRankup](http://www.spigotmc.org/resources/plotrankup.1571/)
* [PlotZSux](https://www.spigotmc.org/resources/plotzsux.9563/)
* [IslandPlots](https://www.spigotmc.org/resources/islandplots.9421/)
* [BiomeGenerator](https://www.spigotmc.org/resources/biomegenerator.1663/)
* [PlotSquaredMG](https://www.spigotmc.org/resources/plotsquaredmg.8025/)
* [BasicPlots](https://www.spigotmc.org/resources/basicplots.6901/)
* [HoloPlots](https://www.spigotmc.org/resources/holoplots.4880/)
